require net
require message
default_sbmessage() { default_short_message; }
encode_sbmessage() { encode_sb "$@"; }
sbmessage() {
__rawmsg sbmessage --port=4444 -t dummy "$@"
}
__rawmsg_sbmessage() {
{
local msg=$(encode_sbmessage "$*")
_sb_init
echo "text c c \"$msg\""
sleep ${SB_TIMEOUT:-10}
echo "quit"
} | _sb_sketch 
}
default_sbxmessage() { default_sbmessage; }
encode_sbxmessage() { encode_sb "$@"; }
sbxmessage() {
__rawmsg sbxmessage --port=4444 -t dummy "$@"
}
__rawmsg_sbxmessage() {
{
local msg lno=0
_sb_init
echo "$*" | while IFS= read -r line; do
msg=$(encode_sbxmessage "$line")
echo "text c $lno \"$msg\""
let lno++
done
sleep ${SB_TIMEOUT:-10}
echo "quit"
} | _sb_sketch 
}
default_sbmarquee() { default_message; }
encode_sbmarquee() { encode_sb "$@"; }
sbmarquee() {
__rawmsg sbmarquee --port=4444 -t dummy "$@"
}
__rawmsg_sbmarquee() {
{
local msg=$(encode_sbmessage "$*")
local n=${SB_TIMES:-3}
local timeout=$((1000 * $(_sb_timeout "$msg")))
local final_timeout=$((1000 * $(SB_OVERLAP=-5 _sb_timeout "$msg")))
_sb_init
while ? "n > 0"; do
echo "marquee -start \"$msg\""
let n--
usleep $((n == 0 ? final_timeout : timeout))
done
echo "quit"
} | _sb_sketch
}
_sb_timeout() {
local msg=$1
local len=${#msg}
local visible=${SB_VISIBLE:-35}
local overlap=${SB_OVERLAP:-10}
local speed=${SB_SPEED:-7200} ## milli-chars per second :o)
local time
let "time = (len + visible - overlap) * 1000000 / speed" ## milliseconds
echo $((time < 0 ? 0 : time))
}
encode_sb() {
case $1 in
*[\"\\]*) echo $1 | sed -e 's/["\]/\\&/g' ;;
*) echo $1 ;;
esac
}
_sb_sketch() {
{
echo "sketch"
cat
} | _connect
}
_sb_init() {
echo "font ${SB_FONT:-2}"
echo "encoding latin1"
echo "clear"
}
